package jdk.internal.org.objectweb.asm.tree.analysis;

import jdk.internal.org.objectweb.asm.tree.AbstractInsnNode;
import java.util.Set;

public class SourceValue implements Value
{
    public final int size;
    public final Set<AbstractInsnNode> insns;
    
    public SourceValue(int n) {
        this(n, SmallSet.emptySet());
    }
    
    public SourceValue(int size, AbstractInsnNode abstractInsnNode) {
        this.size = size;
        this.insns = new SmallSet(abstractInsnNode, null);
    }
    
    public SourceValue(int size, Set<AbstractInsnNode> insns) {
        this.size = size;
        this.insns = insns;
    }
    
    @Override
    public int getSize() {
        return this.size;
    }
    
    @Override
    public boolean equals(Object o) {
        if (!(o instanceof SourceValue)) {
            return false;
        }
        SourceValue sourceValue = (SourceValue)o;
        return this.size == sourceValue.size && this.insns.equals(sourceValue.insns);
    }
    
    @Override
    public int hashCode() {
        return this.insns.hashCode();
    }
}
